//+------------------------------------------------------------------+
//|                                                     TimeStat.mq4 |
//+------------------------------------------------------------------+
/*
                
*/

#property show_inputs
extern color Paint=Blue;
extern color Body=White;
double Metki[2880];
//----
void BarCreate(int Nbar, double Pmin, double Pmax, int Tvolume, bool R, int PeriodBars,int delta)
  {
   static int counter;
   counter++;
   if (R) ObjectCreate("sq"+counter,OBJ_RECTANGLE,0,Time[Nbar+Tvolume],Pmax,Time[Nbar],Pmin);
   else ObjectCreate("sq"+counter,OBJ_RECTANGLE,0,Time[Nbar+PeriodBars+delta],Pmax,Time[Nbar+PeriodBars+delta-Tvolume],Pmin);
   ObjectSet("sq"+counter,OBJPROP_COLOR,Paint);
  }
//----
void BodyCreate(string Name,int index1,double price1,int index2,double price2,color paint)
  {
   ObjectCreate(Name,OBJ_TREND,0,Time[index1],price1,Time[index2],price2);
   ObjectSet(Name,OBJPROP_RAY,false);
   ObjectSet(Name,OBJPROP_COLOR,paint); 
   ObjectSet(Name,OBJPROP_WIDTH,3);  
  }

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
  bool Right=false;
  int PeriodBars,OpClBody,Ccounter,Number,popravka,tVol,summ;
  int i,iii,j,k,kk,l,m,n;
  int TF=Period();
  double MetkiMin,sVol;
  //----
  if (TF>240 || TF<15) 
     {
     ObjectCreate("message",OBJ_LABEL,0,0,0);
     ObjectSetText("message","TF     15     4- .",10,"Times New Roman",White);
     return(0);
     }
  //----
  switch(TF)
     {
     case 15: PeriodBars=48; OpClBody=16; break;
     case 30: PeriodBars=24; OpClBody=8; break;
     case 60: PeriodBars=12; OpClBody=4; break;
     case 240: PeriodBars=3; OpClBody=1; break;
     default: return(0);
     }
  int b=Bars/PeriodBars-1;
  //----
  for (iii=0; iii<96; iii++)
      {
      if (TimeDay(Time[iii])!=TimeDay(Time[iii+1])) {iii++; break;}
      }
  //----
  for (i=0; i<=b; i++)
      {
      for (j=0; j<=PeriodBars-1; j++)
          {
          Number=i*PeriodBars+j+iii;
          k=PeriodBars*2-1; kk=k;
          //----
          while (k>=0)
                {
                if (High[Number]>Metki[k])
                   {
                   if (k==0) {Metki[0]=High[Number]; break;}
                   for (l=0; l<=k-1; l++) Metki[l]=Metki[l+1];
                   Metki[k]=High[Number]; kk=k;
                   break;
                   }
                k--;
                }
          //----
          while (kk>=0)
                {
                if (Low[Number]>Metki[kk])
                   {
                   if (kk==0) {Metki[0]=Low[Number]; break;}
                   for (l=0; l<=kk-1; l++) Metki[l]=Metki[l+1];
                   Metki[kk]=Low[Number];
                   break;
                   }
                kk--;
                }
          //----
          if (TimeDay(Time[Number])!=TimeDay(Time[Number+1])) {popravka=j+1-PeriodBars; break;}
          if (TimeHour(Time[Number])>=12 && TimeHour(Time[Number+1])<12) {popravka=j+1-PeriodBars; break;}          
          }
      //----
      for (j=0; j<=PeriodBars*2-1;j++)
          {
          if (Metki[j]>0) {MetkiMin=Metki[j];break;}
          }
      //----
      Ccounter++;
      sVol=0.0;
      summ=0;
      //----
      for (m=0; m<=PeriodBars*2-2; m++)
          {
          tVol=0;
          for (n=0; n<=PeriodBars-1; n++)
              {
              Number=i*PeriodBars+n+iii;
              if ((Metki[m]+Metki[m+1])/2.0>=Low[Number] && (Metki[m]+Metki[m+1])/2.0<=High[Number]) tVol++;
              }
          sVol+=tVol*(Metki[m]+Metki[m+1])/2.0;
          summ+=tVol;
          BarCreate(i*PeriodBars+iii,Metki[m],Metki[m+1],tVol,Right,PeriodBars,popravka); Metki[m]=0.0;
          }
      //----
      if (!Right) 
          {
          ObjectCreate("line"+Ccounter,OBJ_VLINE,0,Time[i*PeriodBars+iii],0);
          ObjectSet("line"+Ccounter,OBJPROP_STYLE,STYLE_DOT);
          BodyCreate("barBody"+Ccounter,(i+1)*PeriodBars+iii+popravka,Metki[PeriodBars*2-1],(i+1)*PeriodBars+iii+popravka,MetkiMin,Body);  
          BodyCreate("closeBody"+Ccounter,(i+1)*PeriodBars+iii+popravka,Close[i*PeriodBars+iii],(i+1)*PeriodBars+iii+popravka-OpClBody,Close[i*PeriodBars+iii],Body);
          BodyCreate("sVol"+Ccounter,(i+1)*PeriodBars+iii+popravka,sVol/summ,(i+1)*PeriodBars+iii+popravka-OpClBody,sVol/summ,Red);
          }
      else
          {
          BodyCreate("barBody"+Ccounter,i*PeriodBars+iii,Metki[PeriodBars*2-1],i*PeriodBars+iii,MetkiMin,Body);  
          BodyCreate("openBody"+Ccounter,i*PeriodBars+iii+OpClBody,Open[(i+1)*PeriodBars+popravka+iii-1],i*PeriodBars+iii,Open[(i+1)*PeriodBars+popravka+iii-1],Body);
          BodyCreate("sVol"+Ccounter,i*PeriodBars+iii+OpClBody,sVol/summ,i*PeriodBars+iii,sVol/summ,Red);
          }
      //----
      Metki[PeriodBars*2-1]=0.0; Right=!Right; iii+=popravka;
      }
  //----
   return(0);
  }
//+------------------------------------------------------------------+